import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;

public class CaddySQL
{

final int nCharFormFeed = 12;
String datadir = "sqldata";

public CaddySQL()
{ 
    System.out.println("CaddySQL version 1.0 - Active");
}

synchronized int Query(String sQuery, Vector entries)
{

    int result = 0;
    StringTokenizer ST = new StringTokenizer(sQuery, " ");
    while(ST.hasMoreTokens())
    {
        String token = ST.nextToken().toUpperCase();
    
        if(token.compareTo("INSERT") == 0)
        {
          result = handleSQLInsert(ST);
        }
        else
        if(token.compareTo("CREATE") == 0)
        {
          result = handleSQLCreate(ST);
        }
        else
        if(token.compareTo("SELECT") == 0)
        {
          result = handleSQLSelect(ST, entries);
        }    
        else
        if(token.compareTo("UPDATE") == 0)
        {
          result = handleSQLUpdate(ST);
        }
        else
        if(token.compareTo("SHOW") == 0)
        {
          result = handleSQLShow(ST, entries);
        }   
        /*
        else
        if(token.compareTo() == 0)
        {}
        else
        if(token.compareTo() == 0)
        {}
        */
    
    }
    //parseQuery();

    //Release our mutex lock
    notifyAll();
    
    return result;
}

int handleSQLInsert(StringTokenizer ST)
{
String token;
 String sTableName = "";
      Vector valueVector = new Vector(0,1);

      token = SafeToken(ST).toUpperCase();
      if(token.length() == 0)
      return 1;

      if(token.compareTo("INTO") == 0)
      {
          //Get Table Name
          token = SafeToken(ST);
          if(token.length() == 0)
          return 1;

          sTableName = token;

          StringTokenizer values = new StringTokenizer(SafeToken(ST), "(,)");

          token = SafeToken(values).toUpperCase();
          if(token.compareTo("VALUES") == 0)
          {
             while(values.hasMoreTokens())
             {
                valueVector.add(FixText(SafeToken(values)));
             }
          }
      }
      else
       return 1;

       //Validate the values.. Simply make sure the proper amount of them exists
       Vector vTableDef = new Vector(0,1);
       GetTableDef(sTableName, vTableDef);

       if(valueVector.size() != vTableDef.size())
       {
           return 1;
       }
       
       //Debug output
       /*
       for(int i = 0; i < vTableDef.size(); i++)
       {
        CaddySQLColumn col = (CaddySQLColumn)vTableDef.elementAt(i);
        System.out.println("Val: "+col.m_sTitle+" "+col.m_nType);
       }
       */
      
       //Debug output
       /*
       for(int i = 0; i < valueVector.size(); i++)
       {
       System.out.println("Val: "+(String)valueVector.elementAt(i));
       }
       */
       //TODO: do the actual work of writing the data out.

       //Open/parse table status file
       String sTableStatusData = GetFile(datadir+"/tables/"+sTableName+"/status.def");
       int nCount = 0;
       StringTokenizer statusTokenizer = new StringTokenizer(sTableStatusData,"=\r\n");
       token = SafeToken(statusTokenizer);
       if(token.compareTo("numentries") == 0)
       {
           nCount = Integer.valueOf((String)SafeToken(statusTokenizer)).intValue();
           System.out.println("Count: "+nCount);
       }

       //Open table database

       //parse table definition. (should do this upon SQL startup)

       //write table entry(in the format of id.txt)
        try
        {
            String filename = datadir+"/tables/"+sTableName+"/"+nCount+".txt" ;
			PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(filename)));
            for(int i = 0; i < valueVector.size(); i++)
            {
                //System.out.println("Val: "+(String)valueVector.elementAt(i));
                out.write((String)valueVector.elementAt(i)+(char)nCharFormFeed);//",");
            }
            out.flush();
			out.close(); 
            
            //Save a reference to this in our entry map
            filename = datadir+"/tables/"+sTableName+"/entries.def";
            String entryMap = GetFile(filename);
            //entryMap.append(""+nCount+"\n");
            SaveFile(filename, entryMap+""+nCount+"\n");

            //Increment the table status count
            nCount++;
            //write status file
            SaveFile(datadir+"/tables/"+sTableName+"/status.def", "numentries="+nCount); 

        }
		catch (Exception exc)
		{
			System.out.println(exc);                         
		}
return 0;
}

int handleSQLCreate(StringTokenizer ST)
{
  //parse input
  String token = SafeToken(ST).toUpperCase();
  String sTableName = "";
  StringBuffer SB = new StringBuffer();

  if(token.compareTo("TABLE") == 0)
  {
    //Get Table Name
    token = SafeToken(ST);
    if(token.length() == 0)
    return 1;

    sTableName = token;

    while(ST.hasMoreTokens())
    {
        StringTokenizer values = new StringTokenizer(SafeToken(ST), "()");
        while(values.hasMoreTokens())
        {
            SB.append(SafeToken(values)+" ");
        }
    }
    
    //create the table
    File table = new File(datadir+"/tables/"+sTableName);
    boolean bCreated = table.mkdirs();
    if(!bCreated)
    return 1;

    //Create default data files
    SaveFile(datadir+"/tables/"+sTableName+"/status.def", "numentries=0"); 
    SaveFile(datadir+"/tables/"+sTableName+"/entries.def", ""); 
    SaveFile(datadir+"/tables/"+sTableName+"/table.def", SB.toString());
    
    //add this to our tables list
    StringBuffer tableList = new StringBuffer(GetFile(datadir+"/tables.def"));
    tableList.append(sTableName+"\n");
    SaveFile(datadir+"/tables.def", tableList.toString());

  }
  else 
   return 1;

return 0;
}

int handleSQLSelect(StringTokenizer ST, Vector results)
{
  //parse input
  String sTableName = "";
  StringBuffer SB = new StringBuffer();

  String columns = SafeToken(ST);

  String token = SafeToken(ST).toUpperCase();
  if(token.compareTo("FROM") == 0)
  {
      sTableName = SafeToken(ST);

      //process where
      String sWhereColumn = "";
      String sWhereValue = "";
      boolean bWhere = false;
      token = SafeToken(ST).toUpperCase();
      if(token.compareTo("WHERE") == 0)
      {
       StringTokenizer stWhere = new StringTokenizer(SafeToken(ST),"=");
       sWhereColumn = SafeToken(stWhere);
       sWhereValue = SafeToken(stWhere);
       bWhere = true;
      }
      
      //open entries
      String sEntryList = GetFile(datadir+"/tables/"+sTableName+"/entries.def");
      StringTokenizer stEntryList = new StringTokenizer(sEntryList,"\n\r");

      Vector vTableDef = new Vector(0,1);
      GetTableDef(sTableName, vTableDef);

      while(stEntryList.hasMoreTokens())
      {
          Vector vColumns = new Vector(0,1);
          String sEntry = SafeToken(stEntryList);
          GetTableEntry(sTableName, sEntry, vColumns);

          boolean bAdd = false;
          boolean bCheckedId = false;
          Vector result = new Vector(0,1);

          //push the id on first
          result.add(sEntry);
          
          for(int i = 0; i < vTableDef.size(); i++)
          {
            //if needed convert the result//note can not convert them at this time return all as text for now

            result.add((String)vColumns.elementAt(i));            

            if(bWhere && !bAdd)
            {
                CaddySQLColumn col = (CaddySQLColumn)vTableDef.elementAt(i);

                if(col.m_sTitle.compareTo(sWhereColumn) == 0)
                {
                    //debug output
                    //System.out.println("333 "+(String)vColumns.elementAt(i)+" =? "+sWhereValue);
                    if( ((String)vColumns.elementAt(i)).compareTo(sWhereValue) == 0)
                    {
                        bAdd = true;
                    }
                }

                //Since the id is not stored in the entry, this is a special case check
                if(!bCheckedId)
                {
                    if(sWhereColumn.compareTo("id") == 0)
                    {
                        if(sEntry.compareTo(sWhereValue) == 0)
                        {
                            bAdd = true;
                        }
                    }

                    bCheckedId = true;
                }

            }
            else
            {
                bAdd = true;
            }

            //result.add(vColumns);
          }

          if(bAdd)
          results.add(result);
      }

  }
  else
  return 1;


return 0;
}

int handleSQLUpdate(StringTokenizer ST)
{
  //parse input
  //String sTableName = "";
  //StringBuffer SB = new StringBuffer();
  Vector vKeys = new Vector(0, 1);
  Vector vValues = new Vector(0, 1);

  String sTableName = SafeToken(ST);

  String token = SafeToken(ST).toUpperCase();

  if(token.compareTo("SET") == 0)
  {
    token = SafeToken(ST);
    if(token.length() == 0)
    return 1;

    StringTokenizer stAssignments = new StringTokenizer(token,",");
    while(stAssignments.hasMoreTokens())
    {
      String subtoken =  SafeToken(stAssignments);
      StringTokenizer stSubAssignments = new StringTokenizer(subtoken,"=");

      vKeys.add(SafeToken(stSubAssignments));
      vValues.add(FixText(SafeToken(stSubAssignments)));
        // Should prolly do a check here.. but for now going to assume valid data
    }

    //for(int i = 0; i < vKeys.size(); i++)
    //System.out.println("-> "+vKeys.elementAt(i)+" = "+vValues.elementAt(i));

  }
  else
    return 1;

  token = SafeToken(ST).toUpperCase();
  if(token.compareTo("WHERE") == 0)
  {
     StringTokenizer stSubAssignments = new StringTokenizer(SafeToken(ST),"=");
     String sKey = SafeToken(stSubAssignments);
     String sValue = SafeToken(stSubAssignments);

     // Search through our entries


     //FIXME: for now, only look through the id column
     //open entries
      String sEntryList = GetFile(datadir+"/tables/"+sTableName+"/entries.def");
      StringTokenizer stEntryList = new StringTokenizer(sEntryList,"\n\r");
      while(stEntryList.hasMoreTokens())
      {
        String entry = SafeToken(stEntryList);
        if(entry.compareTo(sValue) == 0)
        {
            // Now it's time to open and update the entry
            //GetTableEntry(String sTableName, String sEntry, Vector vColumns)
            //GetTableDef(String sTableName, Vector vColumns)
            Vector vTableDef = new Vector(0,1);
            GetTableDef(sTableName, vTableDef);

            Vector vTableEntry = new Vector(0,1);
            GetTableEntry(sTableName, entry, vTableEntry);

            for(int i = 0; i < vTableDef.size(); i++)
            for(int j = 0; j < vKeys.size(); j++)
            {  
                CaddySQLColumn col = (CaddySQLColumn)vTableDef.elementAt(i);
                String sColumnName = col.m_sTitle;
                if(sColumnName.compareTo((String)vKeys.elementAt(j)) == 0)
                {
                    vTableEntry.setElementAt((String)vValues.elementAt(j), i);
                }
            }

            SaveTableEntry(sTableName, sValue, vTableEntry);

        }
      
      }

     //

     //

  }
  else
    return 1; 

return 0;
}


int handleSQLShow(StringTokenizer ST, Vector results)
{

    String token = SafeToken(ST).toUpperCase();

    if(token.compareTo("DATABASE") == 0) 
    {
      String data = GetFile(datadir+"/tables.def");
      StringTokenizer ST2 = new StringTokenizer(data, "\r\n");
      for(int i = 0; ST2.hasMoreTokens(); i++)
      {
	Vector v1 = new Vector(0,1);
	v1.add(""+i);
	v1.add(SafeToken(ST2));
        results.add(v1);
      }

    }else
    if(token.compareTo("TABLE") == 0) 
    {
        token = SafeToken(ST);
        if(!(token.length() > 0))
        return 1;

        GetTableDef(token, results);

    }else
    return 1;
                                
    return 0;
}

String SafeToken(StringTokenizer st)
{
    if(st.hasMoreTokens())
    {
        return st.nextToken();
    }
    else
    {
        return "";
    }
}

int GetTableEntry(String sTableName, String sEntry, Vector vColumns)
{
    String data = GetFile(datadir+"/tables/"+sTableName+"/"+sEntry+".txt");
    StringTokenizer ST = new StringTokenizer(data,""+(char)12);

    while(ST.hasMoreTokens())
    {
        vColumns.add(SafeToken(ST));
    }
return 0;
}

int SaveTableEntry(String sTableName, String sEntry, Vector data)
{
    try
    {
        String filename = datadir+"/tables/"+sTableName+"/"+sEntry+".txt" ;
        PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(filename)));
        for(int i = 0; i < data.size(); i++)
        {
            out.write((String)data.elementAt(i)+(char)nCharFormFeed);
        }
        out.flush();
        out.close();
    }
    catch(Exception e)
    {
        ERROR("CaddySQL::SaveTableEntry -> "+e);
        return 1;
    }

   return 0;
}

int GetTableDef(String sTableName, Vector vColumns)
{
    String sTableDef = GetFile(datadir+"/tables/"+sTableName+"/table.def");

    StringTokenizer ST = new StringTokenizer(sTableDef, ",");

    while(ST.hasMoreTokens())
    {
        String token = SafeToken(ST);
        StringTokenizer entry = new StringTokenizer(token," ");

        String column = SafeToken(entry);
        String type = SafeToken(entry).toUpperCase();

        CaddySQLColumn csc = new CaddySQLColumn();
        csc.m_sTitle = column;
        if(type.compareTo("TEXT") == 0)
        {
           csc.m_nType = 0;
        }
        else
        if(type.compareTo("INT") == 0)
        {
           csc.m_nType = 1;
        }
        else
        if(type.compareTo("FLOAT") == 0)
        {
           csc.m_nType = 2;
        }
       
        /*
        try
        {
            csc.m_nType = Integer.valueOf(type).intValue();
        }
        catch(Exception e)
        {
            csc.m_nType = 0; //default to text
        }
        */
        vColumns.add(csc);

    }

    return 0;
}

String GetFile(String sFilename)
{
	String text = "";
	
	try
    {
		byte[] data;
		File F = new File(sFilename);
		FileInputStream fin = new FileInputStream(F);
		int filesize = (int)F.length();
		data = new byte[filesize];
		fin.read (data, 0, filesize);
		fin.close();
		text = new String (data); //TODO: make this call not deprecated
	}
    catch (Exception e)
    {
		System.out.println("File Not Found: "+e);
    }

    return text;
}


void SaveFile(String sFilename, String data)
{
   try
   {
	   PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(sFilename)));
	   out.write(data);
       out.flush();
	   out.close();                        
    }
	catch (Exception exc)
	{
		System.out.println(exc);                         
	}
}

String FixText(String text)
{
    StringBuffer SB = new StringBuffer(text);
    StringBuffer data = new StringBuffer();
    for(int i = 0; i < SB.length(); i++)
    {
          if(SB.charAt(i) == '%')
          {
            if(SB.length() > i+3)
            {
                String token =  ""+SB.charAt(i+1)+SB.charAt(i+2);
                data.append(""+GetDecodedChar(token));
            }
            i += 2;
          }else
          if(SB.charAt(i) == '+')
          {
            data.append(" ");
          }
          else
          {
              data.append(SB.charAt(i));
          }
    }

    return data.toString();
}

char GetDecodedChar(String sChar)
{

//convert data to decimal
    StringBuffer SB = new StringBuffer(sChar);
    int nSize = SB.length();
    int nChar = 0;
    for(int i = 0; i < nSize; i++)
    {
      int nThisnChar = GetConvertedNumber(SB.charAt(nSize-i-1)) * GetPowerOf16(i);
      nChar += nThisnChar;
      //ERROR("nChar "+nThisnChar+"  "+SB.charAt(nSize-i-1));
    }

    //TEMP
    //ERROR("CHAR = "+nChar+" "+(char)nChar);

    return (char)nChar;

}

int GetPowerOf16(int nPower)
{ 
  return (int)StrictMath.pow(16.0f, (float)nPower);
}

int GetConvertedNumber(char nchar)
{
    int nChar = 0;

    if((nchar > 47)&&(nchar < 58))
    {
    nChar = nchar - 48;
    }

    if((nchar > 64)&&(nchar < 71))
    {
    nChar = nchar - 55;
    }

    return nChar;
}


void ERROR(String error)
{
    System.out.println(error); 
}

} // end all


//
//
//
//
//
//
//
/*
            switch(col.m_nType)
            {
            case 0: //text
            {
               String text = (String)vColumns.elementAt(i);
               result.add(text);
            }
            break;

            case 1: //int
            {
               try
               {
                int inumber = Integer.valueOf((String)vColumns.elementAt(i)).intValue();
                result.add(inumber);
               }
               catch(Exception e)
               {
                result.add(0);
               }               
            }
            break;

            case 2: //float
            {
               try
               {
                float fnumber = Double.valueOf((String)vColumns.elementAt(i)).floatValue();
                result.add(fnumber);
               }
               catch(Exception e)
               {
                result.add(0.0f);
               } 
            }
            break;
            
            default:
            break;
            }
            */
